# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *
import json
import zipfile

# Declaring global variables - Warnings: 1) WAPT context is only available in package functions; 2) Global variables are not persistent between calls

def update_package():
    result = False
    proxies = get_proxies()

    if not proxies:
        proxies = get_proxies_from_wapt_console()
    
    git_repo = "nicotine-plus/nicotine-plus"
    url_api = "https://api.github.com/repos/%s/releases/latest" % git_repo   
    # Getting latest version information from official sources
    print("API used is: %s" % url_api)
    json_load = json.loads(wgets(url_api, proxies=proxies))

    url_dl = None
    filename = None

    for download in json_load["assets"]:
        if download["browser_download_url"].endswith('windows-x86_64-installer.zip'):
            url_dl = download["browser_download_url"]
            version = json_load["tag_name"].replace("v","")
            filename = download["name"]
            break

    if url_dl is None:
        print("No windows-x86_64-installer.zip found in the latest release.")
        return

    if not isfile(filename):
        package_updated = True
        wget(url_dl, filename, proxies=proxies)

    # Unzip the downloaded file to extract the .msi file
    with zipfile.ZipFile(filename, 'r') as zip_ref:
        zip_ref.extractall()

    # Delete the ZIP file after extraction
    if isfile(filename):
        remove_file(filename)
        print(f"Deleted the ZIP file: {filename}")    

    msi_filename = None
    for f in glob.glob('*.msi'):
        msi_filename = f
        break

    if msi_filename:
        print(f"Found .msi file: {msi_filename}")
    else:
        print("No .msi file found in the unzipped content.")

    # Clean up temporary files
    for f in glob.glob('*.zip'):
        if f != filename:
            remove_file(f)

    control.set_software_version(version)
    control.save_control_to_wapt()

